SoGetMatrixAction(3)

NAME
SoGetMatrixAction - The SoGetMatrixAction class is an action for accumulating the transformation matrix of a subgraph.

SYNOPSIS

#include <Inventor/actions/SoGetMatrixAction.h>

Inherits SoAction.

  Public Member Functions
virtual SoType getTypeId (void) const
SoGetMatrixAction (const SbViewportRegion &region)
virtual ~SoGetMatrixAction (void)
void setViewportRegion (const SbViewportRegion &region)
const SbViewportRegion & getViewportRegion (void) const
SbMatrix & getMatrix (void)
SbMatrix & getInverse (void)
SbMatrix & getTextureMatrix (void)
SbMatrix & getTextureInverse (void)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void addMethod (const SoType type, SoActionMethod method)
static void enableElement (const SoType type, const int stackindex)
static void initClass (void)

  Protected Member Functions
virtual const SoEnabledElementsList & getEnabledElements (void) const
virtual void beginTraversal (SoNode *node)

  Static Protected Member Functions
static SoEnabledElementsList * getClassEnabledElements (void)
static SoActionMethodList * getClassActionMethods (void)

  Additional Inherited Members

Detailed Description

The SoGetMatrixAction class is an action for accumulating the transformation matrix of a subgraph. This action makes it easy to calculate and convert to and from the global coordinate system of your scene and local coordinates of parts in a hierarchical model.

As opposed to most other action types, the SoGetMatrixAction does not traverse children of the node it is applied to -- just the node itself. When applied to paths, it stops at the last node and does not continue further with the children of the tail node.

Typical usage when querying for world space position, orientation and/or scaling would be as follows:

// First get hold of an SoPath through the scene graph down to the
// node ("mynode") you want to query about its current world space
// transformation(s).
SoSearchAction * searchaction = new SoSearchAction;
searchaction->setNode(mynode);
searchaction->apply(myscenegraphroot);
SoPath * path = searchaction->getPath();
assert(path != NULL);
// Then apply the SoGetMatrixAction to get the full transformation
// matrix from world space.
const SbViewportRegion vpr = myviewer->getViewportRegion();
SoGetMatrixAction * getmatrixaction = new SoGetMatrixAction(vpr);
getmatrixaction->apply(path);
SbMatrix transformation = getmatrixaction->getMatrix();
// And if you want to access the individual transformation
// components of the matrix:
SbVec3f translation;
SbRotation rotation;
SbVec3f scalevector;
SbRotation scaleorientation;
transformation.getTransform(translation, rotation, scalevector, scaleorientation);

Constructor & Destructor Documentation

  SoGetMatrixAction::SoGetMatrixAction (const SbViewportRegion & region)
Constructor.

The region viewport specification is not used by this action, and is passed along in case it is needed by any nodes.

  SoGetMatrixAction::~SoGetMatrixAction (void) [virtual]
Destructor.

Member Function Documentation

  SoType SoGetMatrixAction::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoAction. This is used for runtime type checking and 'downward' casting.

Implements SoAction.

  SoType SoGetMatrixAction::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  void SoGetMatrixAction::addMethod (const SoType type, SoActionMethod method) [static]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  void SoGetMatrixAction::enableElement (const SoType type, const int stackindex) [static]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  const SoEnabledElementsList & SoGetMatrixAction::getEnabledElements (void) const [protected], [virtual]
Returns list of enabled elements.

Reimplemented from SoAction.

  SoEnabledElementsList * SoGetMatrixAction::getClassEnabledElements (void) [static], [protected]
Returns list of enabled elements for this class. The enabledElements and methods variables are protected in the original OIV API. This is not such a good idea, since exposed static class member variables is a major grievance with regard to Win32 DLLs. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

  SoActionMethodList * SoGetMatrixAction::getClassActionMethods (void) [static], [protected]
Returns list of action methods for this class. The enabledElements and methods variables are protected in the original OIV API. This is not such a good idea, since exposed static class member variables is a major grievance with regard to Win32 DLLs. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

  void SoGetMatrixAction::setViewportRegion (const SbViewportRegion & region)
Set the viewport region.

See also
    SoGetMatrixAction::SoGetMatrixAction()

  const SbViewportRegion & SoGetMatrixAction::getViewportRegion (void) const
Returns the viewport region for the action instance.

  SbMatrix & SoGetMatrixAction::getMatrix (void)
Returns the accumulated transformation matrix.

Note: don't modify the returned matrix. This should only be done if you are implementing your own transformation type node extensions. This advice is also valid for the other matrix access methods documented below.

  SbMatrix & SoGetMatrixAction::getInverse (void)
Returns the inverse of the accumulated transformation matrix.

  SbMatrix & SoGetMatrixAction::getTextureMatrix (void)
Returns the accumulated texture matrix.

  SbMatrix & SoGetMatrixAction::getTextureInverse (void)
Returns the inverse of the accumulated texture matrix.

  void SoGetMatrixAction::beginTraversal (SoNode * node) [protected], [virtual]
This virtual method is called from SoAction::apply(), and is the entry point for the actual scene graph traversal.

It can be overridden to initialize the action at traversal start, for specific initializations in the action subclasses inheriting SoAction.

Default method just calls traverse(), which any overridden implementation of the method must do too (or call SoAction::beginTraversal()) to trigger the scene graph traversal.

Reimplemented from SoAction.

Author

Generated automatically by Doxygen for Coin from the source code.